#ifndef SGMLTAG_H
#define SGMLTAG_H

#include <wchar.h>
#define XTRAXML 1
class html_tag_class;

typedef enum {notag,tag,endoftag,endoftag_startoftag} estate;
extern estate (html_tag_class::*tagState)(wint_t kar);
extern void dummyCallBack(void *);
class html_tag_class
    {
    private:
        void * arg;
#if XTRAXML
        void (*CallBackStartScript)(void *); // called when <? has been read
        void (*CallBackEndScript)(void *);  // called when <? > or <? ? or <? < has been read
        void (*CallBackStartMarkUp)(void *); // called when < has been read
        void (*CallBackEndMarkUp)(void *); // called when < > has been read and the markup is not script, comment CDATA or a tag.
        void (*CallBackStartComment)(void *); // called when <!-- has been read
        void (*CallBackEndComment)(void *); // called when <!-- -- has been read
        void (*CallBackStartDOCTYPE)(void *); // called when <!DOCTYPE [ has been read
        void (*CallBackEndDOCTYPE)(void *); // called when <!DOCTYPE [ ]> has been read
        void (*CallBackStartCDATA)(void *); // called when <![CDATA[ has been read
        void (*CallBackEndCDATA)(void *); // called when <![CDATA[ ]]> has been read
#endif
        void (*CallBackStartElementName)(void *);
        void (*CallBackEndElementName)(void *);
        void (*CallBackStartAttributeName)(void *);
        void (*CallBackEndAttributeName)(void *);
        void (*CallBackStartValue)(void *);
        void (*CallBackEndValue)(void *);
        void (*CallBackEndTag)(void *);
        void (*CallBackEmptyTag)(void *);
        void (*CallBackNoMoreAttributes)(void *);
    public:
        estate def(wint_t kar);
        estate lt(wint_t kar);
        estate element(wint_t kar);
        estate elementonly(wint_t kar);
        estate gt(wint_t kar);
        estate emptytag(wint_t kar);
        estate atts(wint_t kar);
        estate name(wint_t kar);
        estate value(wint_t kar);
        estate atts_or_value(wint_t kar);
        estate invalue(wint_t kar);
        estate insinglequotedvalue(wint_t kar);
        estate indoublequotedvalue(wint_t kar);
        estate singlequotes(wint_t kar);
        estate doublequotes(wint_t kar);
        estate endvalue(wint_t kar);
        estate markup(wint_t kar);
        estate script(wint_t kar);
        estate endscript(wint_t kar);
        estate DOCTYPE1(wint_t kar);
        estate DOCTYPE2(wint_t kar);
        estate DOCTYPE3(wint_t kar);
        estate DOCTYPE4(wint_t kar);
        estate DOCTYPE5(wint_t kar);
        estate DOCTYPE6(wint_t kar);
        estate DOCTYPE7(wint_t kar);
        estate DOCTYPE8(wint_t kar);
        estate DOCTYPE9(wint_t kar);
        estate DOCTYPE10(wint_t kar);
        estate h1(wint_t kar);
        estate h2(wint_t kar);
        estate h3(wint_t kar);
        estate CDATA1(wint_t kar);
        estate CDATA2(wint_t kar);
        estate CDATA3(wint_t kar);
        estate CDATA4(wint_t kar);
        estate CDATA5(wint_t kar);
        estate CDATA6(wint_t kar);
        estate CDATA7(wint_t kar);
        estate CDATA8(wint_t kar);
        estate CDATA9(wint_t kar);
        estate endtag(wint_t kar);
        html_tag_class(void * arg):arg(arg)
            {
#if XTRAXML
            CallBackStartScript =
            CallBackEndScript =
            CallBackStartMarkUp =
            CallBackEndMarkUp =
            CallBackStartComment =
            CallBackEndComment =
            CallBackStartDOCTYPE =
            CallBackEndDOCTYPE =
            CallBackStartCDATA =
            CallBackEndCDATA =
#endif
            CallBackStartElementName = 
            CallBackEndElementName =
            CallBackStartAttributeName = 
            CallBackEndAttributeName =
            CallBackStartValue = 
            CallBackEndValue = 
                dummyCallBack;
            tagState = &html_tag_class::def;

            }
#if XTRAXML
        void setCallBackStartScript(void (*f)(void *))      {CallBackStartScript = f;}
        void setCallBackEndScript(void (*f)(void *))        {CallBackEndScript = f;}
        void setCallBackStartMarkUp(void (*f)(void *))      {CallBackStartMarkUp = f;}
        void setCallBackEndMarkUp(void (*f)(void *))        {CallBackEndMarkUp = f;}
        void setCallBackStartComment(void (*f)(void *))     {CallBackStartComment = f;}
        void setCallBackEndComment(void (*f)(void *))       {CallBackEndComment = f;}
        void setCallBackStartDOCTYPE(void (*f)(void *))     {CallBackStartDOCTYPE = f;}
        void setCallBackEndDOCTYPE(void (*f)(void *))       {CallBackEndDOCTYPE = f;}
        void setCallBackStartCDATA(void (*f)(void *))       {CallBackStartCDATA = f;}
        void setCallBackEndCDATA(void (*f)(void *))         {CallBackEndCDATA = f;}
#endif
        void setCallBackStartElementName(void (*f)(void *))
            {
            CallBackStartElementName = f;
            }
        void setCallBackEndElementName(void (*f)(void *))
            {
            CallBackEndElementName = f;
            }
        void setCallBackStartAttributeName(void (*f)(void *))
            {
            CallBackStartAttributeName = f;
            }
        void setCallBackEndAttributeName(void (*f)(void *))
            {
            CallBackEndAttributeName = f;
            }
        void setCallBackStartValue(void (*f)(void *))
            {
            CallBackStartValue = f;
            }
        void setCallBackEndValue(void (*f)(void *))
            {
            CallBackEndValue = f;
            }
        void setCallBackEndTag(void (*f)(void *))
            {
            CallBackEndTag = f;
            }
        void setCallBackEmptyTag(void (*f)(void *))
            {
            CallBackEmptyTag = f;
            }
        void setCallBackNoMoreAttributes(void (*f)(void *))
            {
            CallBackNoMoreAttributes = f;
            }
    };

#endif
